Index: trunk/external-alma/atnf/PKSIO/NROFITSDataset.cc
===================================================================
--- trunk/external-alma/atnf/PKSIO/NROFITSDataset.cc	(revision 2783)
+++ trunk/external-alma/atnf/PKSIO/NROFITSDataset.cc	(revision 2784)
@@ -66,5 +66,5 @@
 
   // field names, units, and sizes
-  readHeader( numField_, "TFIELDS", same_ ) ;
+  readHeader( numField_, "TFIELDS" ) ;
   names_.resize( numField_ ) ;
   units_.resize( numField_ ) ;
@@ -96,9 +96,9 @@
   // initialization
   int status = 0 ;
-  status = readHeader( ARYNM, "ARYNM", same_ ) ;
+  status = readHeader( ARYNM, "ARYNM" ) ;
   if ( status != 0 ) 
     ARYNM = 1 ;
-  readHeader( rowNum_, "NAXIS2", same_ ) ;
-  readHeader( scanLen_, "NAXIS1", same_ ) ;
+  readHeader( rowNum_, "NAXIS2" ) ;
+  readHeader( scanLen_, "NAXIS1" ) ;
   status = 0 ;
   scanNum_ = rowNum_ / ARYNM ;
@@ -264,5 +264,5 @@
   //cout << "LOETM = \'" << LOETM << "\'" << endl ;
   //
-  if ( readHeader( NSCAN, "NAXIS2", sameEndian ) != 0 ) {
+  if ( readHeader( NSCAN, "NAXIS2" ) != 0 ) {
     os << LogIO::WARN << "Error while reading data NSCAN." << LogIO::POST ;
     return -1 ;
@@ -295,5 +295,5 @@
   //cout << "OBJ = \'" << OBJ << "\'" << endl ;
   //
-  if ( readHeader( ftmp, "EPOCH", sameEndian ) != 0 ) {
+  if ( readHeader( ftmp, "EPOCH" ) != 0 ) {
     os << LogIO::WARN << "Error while reading data EPOCH." << LogIO::POST ;
     return -1 ;
@@ -327,5 +327,5 @@
   //cout << "DEC0 = " << DEC0 << endl ;
   //
-  if ( readHeader( GLNG0, "GL0", sameEndian ) != 0 ) {
+  if ( readHeader( GLNG0, "GL0" ) != 0 ) {
     os << LogIO::WARN << "Error while reading data GLNG0." << LogIO::POST ;
     return -1 ;
@@ -334,5 +334,5 @@
   //cout << "GLNG0 = " << GLNG0 << endl ;
   //
-  if ( readHeader( GLAT0, "GB0", sameEndian ) != 0 ) {
+  if ( readHeader( GLAT0, "GB0" ) != 0 ) {
     os << LogIO::WARN << "Error while reading data GLAT0." << LogIO::POST ;
     return -1 ;
@@ -341,5 +341,5 @@
   //cout << "GLAT0 = " << GLAT0 << endl ;
   //
-  if ( readHeader( NCALB, "NCALB", sameEndian ) != 0 ) {
+  if ( readHeader( NCALB, "NCALB" ) != 0 ) {
     os << LogIO::WARN << "Error while reading data NCALB." << LogIO::POST ;
     return -1 ;
@@ -348,5 +348,5 @@
   //cout << "NCALB = " << NCALB << endl ;
   //
-  if ( readHeader( SCNCD, "SCNCD", sameEndian ) != 0 ) {
+  if ( readHeader( SCNCD, "SCNCD" ) != 0 ) {
     os << LogIO::NORMAL << "SCNCD set to 0 (RADEC)." << LogIO::POST ;
     SCNCD = 0 ;
@@ -398,5 +398,5 @@
   //cout << "SCMOD = \'" << SCMOD << "\'" << endl ;
   //
-  if ( readHeader( URVEL, "VEL", sameEndian ) != 0 ) {
+  if ( readHeader( URVEL, "VEL" ) != 0 ) {
     os << LogIO::WARN << "Error while reading data URVEL." << LogIO::POST ;
     return -1 ;
@@ -426,5 +426,5 @@
   //cout << "SWMOD = \'" << SWMOD << "\'" << endl ;
   //
-  if ( readHeader( FRQSW, "FRQSW", sameEndian ) != 0 ) {
+  if ( readHeader( FRQSW, "FRQSW" ) != 0 ) {
     os << LogIO::NORMAL << "FRQSW set to 0." << LogIO::POST ;
     FRQSW = 0.0 ;
@@ -433,5 +433,5 @@
   //cout << "FRQSW = " << FRQSW << endl ;
   //
-  if ( readHeader( DBEAM, "DBEAM", sameEndian ) != 0 ) {
+  if ( readHeader( DBEAM, "DBEAM" ) != 0 ) {
     os << LogIO::WARN << "Error while reading data DBEAM." << LogIO::POST ;
     return -1 ;
@@ -440,5 +440,5 @@
   //cout << "DBEAM = " << DBEAM << endl ;
   //
-  if ( readHeader( MLTOF, "MLTOF", sameEndian ) != 0 ) {
+  if ( readHeader( MLTOF, "MLTOF" ) != 0 ) {
     os << LogIO::NORMAL << "MLTOF set to 0." << LogIO::POST ;
     MLTOF = 0.0 ;
@@ -447,5 +447,5 @@
   //cout << "MLTOF = " << MLTOF << endl ;
   //
-  if ( readHeader( CMTQ, "CMTQ", sameEndian ) != 0 ) {
+  if ( readHeader( CMTQ, "CMTQ" ) != 0 ) {
     os << LogIO::WARN << "Error while reading data CMTQ." << LogIO::POST ;
     return -1 ;
@@ -454,5 +454,5 @@
   //cout << "CMTQ = " << CMTQ << endl ;
   //
-  if ( readHeader( CMTE, "CMTE", sameEndian ) != 0 ) {
+  if ( readHeader( CMTE, "CMTE" ) != 0 ) {
     os << LogIO::WARN << "Error while reading data CMTE." << LogIO::POST ;
     return -1 ;
@@ -461,5 +461,5 @@
   //cout << "CMTE = " << CMTE << endl ;
   //
-  if ( readHeader( CMTSOM, "CMTSOM", sameEndian ) != 0 ) {
+  if ( readHeader( CMTSOM, "CMTSOM" ) != 0 ) {
     os << LogIO::WARN << "Error while reading data CMTSOM." << LogIO::POST ;
     return -1 ;
@@ -468,5 +468,5 @@
   //cout << "CMTSOM = " << CMTSOM << endl ;
   //
-  if ( readHeader( CMTNODE, "CMTNODE", sameEndian ) != 0 ) {
+  if ( readHeader( CMTNODE, "CMTNODE" ) != 0 ) {
     os << LogIO::WARN << "Error while reading data CMTNODE." << LogIO::POST ;
     return -1 ;
@@ -475,5 +475,5 @@
   //cout << "CMTNODE = " << CMTNODE << endl ;
   //
-  if ( readHeader( CMTI, "CMTI", sameEndian ) != 0 ) {
+  if ( readHeader( CMTI, "CMTI" ) != 0 ) {
     os << LogIO::WARN << "Error while reading data CMTI." << LogIO::POST ;
     return -1 ;
@@ -489,5 +489,5 @@
   //cout << "CMTTM = \'" << CMTTM << "\'" << endl ;
   //
-  if ( readHeader( SBDX, "SDBX", sameEndian ) != 0 ) {
+  if ( readHeader( SBDX, "SDBX" ) != 0 ) {
     os << LogIO::WARN << "Error while reading data SBDX." << LogIO::POST ;
     return -1 ;
@@ -496,5 +496,5 @@
   //cout << "SBDX = " << SBDX << endl ;
   //
-  if ( readHeader( SBDY, "SDBY", sameEndian ) != 0 ) {
+  if ( readHeader( SBDY, "SDBY" ) != 0 ) {
     os << LogIO::WARN << "Error while reading data SBDY." << LogIO::POST ;
     return -1 ;
@@ -503,5 +503,5 @@
   //cout << "SBDY = " << SBDY << endl ;
   //
-  if ( readHeader( SBDZ1, "SDBZ1", sameEndian ) != 0 ) {
+  if ( readHeader( SBDZ1, "SDBZ1" ) != 0 ) {
     os << LogIO::WARN << "Error while reading data SBDZ1." << LogIO::POST ;
     return -1 ;
@@ -510,5 +510,5 @@
   //cout << "SBDZ1 = " << SBDZ1 << endl ;
   //
-  if ( readHeader( SBDZ2, "SDBZ2", sameEndian ) != 0 ) {
+  if ( readHeader( SBDZ2, "SDBZ2" ) != 0 ) {
     os << LogIO::WARN << "Error while reading data SBDZ2." << LogIO::POST ;
     return -1 ;
@@ -517,5 +517,5 @@
   //cout << "SBDZ2 = " << SBDZ2 << endl ;
   //
-  if ( readHeader( DAZP, "DAZP", sameEndian ) != 0 ) {
+  if ( readHeader( DAZP, "DAZP" ) != 0 ) {
     os << LogIO::NORMAL << "DAZP set to 0." << LogIO::POST ;
     DAZP = 0.0 ;
@@ -524,5 +524,5 @@
   //cout << "DAZP = " << DAZP << endl ;
   //
-  if ( readHeader( DELP, "DELP", sameEndian ) != 0 ) {
+  if ( readHeader( DELP, "DELP" ) != 0 ) {
     os << LogIO::NORMAL << "DELP set to 0." << LogIO::POST ;
     DELP = 0.0 ;
@@ -531,5 +531,5 @@
   //cout << "DELP = " << DELP << endl ;
   //
-  if ( readHeader( CHBIND, "CHBIND", sameEndian ) != 0 ) {
+  if ( readHeader( CHBIND, "CHBIND" ) != 0 ) {
     os << LogIO::NORMAL << "CHBIND set to 1." << LogIO::POST ;
     CHBIND = 1 ;
@@ -538,5 +538,5 @@
   //cout << "CHBIND = " << CHBIND << endl ;
   //
-  if ( readHeader( NUMCH, "NCH", sameEndian ) != 0 ) {
+  if ( readHeader( NUMCH, "NCH" ) != 0 ) {
     if ( readTable( NUMCH, "NCH", sameEndian ) != 0 ) {
       os << LogIO::NORMAL << "NUMCH set to " << chmax_ << "." << LogIO::POST ;
@@ -547,5 +547,5 @@
   //cout << "NUMCH = " << NUMCH << endl ;
   //
-  if ( readHeader( CHMIN, "CHMIN", sameEndian ) != 0 ) {
+  if ( readHeader( CHMIN, "CHMIN" ) != 0 ) {
     os << LogIO::NORMAL << "CHMIN set to 1." << LogIO::POST ;
     CHMIN = 1 ;
@@ -554,5 +554,5 @@
   //cout << "CHMIN = " << CHMIN << endl ;
   //
-  if ( readHeader( CHMAX, "CHMAX", sameEndian ) != 0 ) {
+  if ( readHeader( CHMAX, "CHMAX" ) != 0 ) {
     os << LogIO::NORMAL << "CHMAX set to " << chmax_ << "." << LogIO::POST ;
     CHMAX = chmax_ ;
@@ -561,5 +561,5 @@
   //cout << "CHMAX = " << CHMAX << endl ;
   //
-  if ( readHeader( ALCTM, "ALCTM", sameEndian ) != 0 ) {
+  if ( readHeader( ALCTM, "ALCTM" ) != 0 ) {
     if ( readTable( ALCTM, "ALCTM", sameEndian ) != 0 ) {
       os << LogIO::WARN << "Error while reading data ALCTM." << LogIO::POST ;
@@ -571,5 +571,5 @@
   //
   int itmp ;
-  if ( readHeader( itmp, "INTEG", sameEndian ) != 0 ) {
+  if ( readHeader( itmp, "INTEG" ) != 0 ) {
     if ( readTable( itmp, "INTEG", sameEndian ) != 0 ) {
       os << LogIO::WARN << "Error while reading data IPTIM." << LogIO::POST ;
@@ -581,5 +581,5 @@
   //cout << "IPTIM = " << IPTIM << endl ;
   //
-  if ( readHeader( PA, "PA", sameEndian ) != 0 ) {
+  if ( readHeader( PA, "PA" ) != 0 ) {
     if ( readTable( PA, "PA", sameEndian ) != 0 ) {
       os << LogIO::WARN << "Error while reading data PA." << LogIO::POST ;
@@ -804,5 +804,5 @@
 //   nro_debug_output( "CWCAL", ARYNM, 10, CWCAL ) ;
   //
-  if ( readHeader( SCNLEN, "NAXIS1", sameEndian ) != 0 ) {
+  if ( readHeader( SCNLEN, "NAXIS1" ) != 0 ) {
     os << LogIO::WARN << "Error while reading data SCNLEN." << LogIO::POST ;
     return -1 ;
@@ -811,5 +811,5 @@
   //cout << "SCNLEN = " << SCNLEN << endl ;
   //
-  if ( readHeader( SBIND, "SBIND", sameEndian ) != 0 ) {
+  if ( readHeader( SBIND, "SBIND" ) != 0 ) {
     os << LogIO::NORMAL << "SBIND set to 0." << LogIO::POST ;
     SBIND = 0 ;
@@ -818,5 +818,5 @@
   //cout << "SBIND = " << SBIND << endl ;
   //
-  if ( readHeader( IBIT, "IBIT", sameEndian ) != 0 ) {
+  if ( readHeader( IBIT, "IBIT" ) != 0 ) {
     os << LogIO::NORMAL << "IBIT set to 8." << LogIO::POST ;
     IBIT = 8 ;  // 8 bit? 12 bit?
@@ -1802,5 +1802,5 @@
 }
 
-int NROFITSDataset::readHeader( int &v, char *name, int /*b*/ ) 
+int NROFITSDataset::readHeader( int &v, char *name ) 
 {
   //
@@ -1838,5 +1838,5 @@
 
 
-int NROFITSDataset::readHeader( float &v, char *name, int /*b*/ ) 
+int NROFITSDataset::readHeader( float &v, char *name ) 
 {
   //
@@ -1872,5 +1872,5 @@
 }
 
-int NROFITSDataset::readHeader( double &v, char *name, int /*b*/ ) 
+int NROFITSDataset::readHeader( double &v, char *name ) 
 {
   //